//+------------------------------------------------------------------+
//|                                                e-CloseOnTime.mq4 |
//|                                             . aka KimIV |
//|                                              http://www.kimiv.ru |
//|                                                                  |
//| 2005.11.01        .       |
//| 2009.09.22  v1.1 myst                                             |
//+------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"
#define  NL    "\n"

//---- input parameters
extern int   CloseHour     = 7;      //  , 
extern int   CloseMinute   = 0;      //  , 
//extern bool  UseCurrSymbol = False;  //    
//extern bool  UseOneAccount = False;  //    
//extern int   NumberAccount = 11111;  //   
extern int   RDBMagicNumber11 = 23714431;  //   
extern int   RDBMagicNumber12 = 23714432;  //   
extern int   RDBMagicNumber13 = 23714433;  //   
extern int   RDBMagicNumber14 = 23714434;  //   
extern int   RDBMagicNumber21 = 93714431;  //   
extern int   RDBMagicNumber22 = 93714432;  //   
extern int   RDBMagicNumber23 = 93714433;  //   
extern int   RDBMagicNumber24 = 93714434;  //   
extern int   OtherMagicNumber1 = 1;  //   
extern int   OtherMagicNumber2 = 2;  //   
extern int   OtherMagicNumber3 = 3;  //   
extern int   OtherMagicNumber4 = 4;  //   
extern int   OtherMagicNumber5 = 5;  //   
extern int   Slippage      = 300;      //  
extern color clCloseBuy    = Blue;   //   
extern color clCloseSell   = Red;    //   

void start() {
  double pBid, pAsk;
  int MN;
  
  string Message;
//      Comment("CloseTime = " + CloseHour + ":" + CloseMinute);
      Message = "CloseTime = " + CloseHour + ":" + CloseMinute + NL;
/*
  if (UseOneAccount && AccountNumber()!=NumberAccount) {
    Comment("  : "+AccountNumber()+" !");
    return;
  } else Comment("");
*/
  if (Hour()==CloseHour && Minute()>=CloseMinute) {
//      Comment("ClosingTime");
      Message = Message + "ClosingTime" + NL;
    for (int i=OrdersTotal()-1; i>=0; i--) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         MN = OrderMagicNumber( );
         if(MN != RDBMagicNumber11 && MN != RDBMagicNumber12 && MN != RDBMagicNumber13 && MN != RDBMagicNumber14 && MN != RDBMagicNumber21 && MN != RDBMagicNumber22 && MN != RDBMagicNumber23 && MN != RDBMagicNumber24 && MN != OtherMagicNumber1 && MN != OtherMagicNumber2 && MN != OtherMagicNumber3 && MN != OtherMagicNumber4 && MN != OtherMagicNumber5){
//         if (!UseCurrSymbol || OrderSymbol()==Symbol()) {
           if (OrderType()==OP_BUY) {
             pBid=MarketInfo(OrderSymbol(), MODE_BID);
             OrderClose(OrderTicket(), OrderLots(), pBid, Slippage, clCloseBuy);
           }
           if (OrderType()==OP_SELL) {
             pAsk=MarketInfo(OrderSymbol(), MODE_ASK);
             OrderClose(OrderTicket(), OrderLots(), pAsk, Slippage, clCloseSell);
           }
//         }
         }
      }
    }
  }else{
      Message = Message + "NotClosingTime" + NL;
  }
  
      Message = Message + " = Exclusion = " + NL;
      Message = Message + "RDBMagicNumber11 = " + RDBMagicNumber11 + NL;
      Message = Message + "RDBMagicNumber12 = " + RDBMagicNumber12 + NL;
      Message = Message + "RDBMagicNumber13 = " + RDBMagicNumber13 + NL;
      Message = Message + "RDBMagicNumber14 = " + RDBMagicNumber14 + NL;
      Message = Message + "RDBMagicNumber21 = " + RDBMagicNumber21 + NL;
      Message = Message + "RDBMagicNumber22 = " + RDBMagicNumber22 + NL;
      Message = Message + "RDBMagicNumber23 = " + RDBMagicNumber23 + NL;
      Message = Message + "RDBMagicNumber24 = " + RDBMagicNumber24 + NL;
      Message = Message + "OtherMagicNumber1 = " + OtherMagicNumber1 + NL;
      Message = Message + "OtherMagicNumber2 = " + OtherMagicNumber2 + NL;
      Message = Message + "OtherMagicNumber3 = " + OtherMagicNumber3 + NL;
      Message = Message + "OtherMagicNumber4 = " + OtherMagicNumber4 + NL;
      Message = Message + "OtherMagicNumber5 = " + OtherMagicNumber5 + NL;
      Message = Message + " ============= ";
  Comment(Message);
}
//+------------------------------------------------------------------+